﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using RTSXQuery_Lib;
//PS: You must include reference to RTSXQuery_lib.dll file using option "Project >> Add Reference"

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        
        //Create Class objects
        RTSlink oRTSlink = new RTSlink();           //Provides Tally to XML (and XML to Tally) functionality
        RTSXQuery oRTSXQuery = new RTSXQuery();     //Provides XML to Database functionality
        RTSMisc oRTSMisc = new RTSMisc();           //Provides general functions


        //=======================================================================================================
        //TO DO - START
        //=======================================================================================================
        //Specify the ConnectionString to connect to your database 
        //Subsitute the value in the connection sring   Source= SHWETASOFTWARES\\SQLEXPRESS
        //string strConnectionString = "Provider=sqloledb;Data Source=SHWETASOFTWARES\\SQLEXPRESS;Initial Catalog=Tally;Integrated Security=SSPI;";
        string strConnectionString = "";

        //Specify the PATH where RTSXQuery DLL (library) is installed
        //string strRTSXQueryPATH = "C:\\RTSXQuery_LibV1.0\\";
        string strRTSXQueryPATH = "";
        //=======================================================================================================
        //TO DO - END
        //=======================================================================================================

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }


        //Process Vouchers
        private void button1_Click(object sender, EventArgs e)
        {

            //Connection String
            strConnectionString = txtBoxConnectionString.Text.Trim();
            //MessageBox.Show(strConnectionString);

            strRTSXQueryPATH = txtBoxRTSXQueryPath.Text.Trim()+"\\";
            //MessageBox.Show(strRTSXQueryPATH);
            
            //Path where RTSXQuery is installed 
            oRTSMisc.RTSXQueryPATH = strRTSXQueryPATH;
            
            //Check whether Tally is running
            if (oRTSlink.Open() != 0)
            {
                MessageBox.Show(oRTSlink.LastErrorMessage);
                Application.Exit();
                return;
            }

            //Add vouchers to sql-database         (i.e. the newly created vouchers in Tally after last synchronize are added to sql-database)
            //Update vouchers in sql-database      (i.e. only those vouchers which have been altered in Tally after last synchronize)
            button1.Enabled = false;
            ProcessVouchers();
            button1.Enabled = true;
            MessageBox.Show("Process Completed");
        }

        //Process Masters
        private void button2_Click(object sender, EventArgs e)
        {

            //Connection String
            strConnectionString = txtBoxConnectionString.Text.Trim();
            //MessageBox.Show(strConnectionString);

            strRTSXQueryPATH = txtBoxRTSXQueryPath.Text.Trim() + "\\";
            //MessageBox.Show(strRTSXQueryPATH);
            
            //Path where RTSXQuery is installed 
            oRTSMisc.RTSXQueryPATH = strRTSXQueryPATH;

            //Check whether Tally is running
            if (oRTSlink.Open() != 0)
            {
                MessageBox.Show(oRTSlink.LastErrorMessage);
                Application.Exit();
                return;
            }
            button2.Enabled = false;

            //Path where RTSXQuery is installed and if files are kept
            oRTSMisc.RTSXQueryPATH = strRTSXQueryPATH;

            //Add Masters to sql-database
            ProcessMasters();

            button2.Enabled = true;
            MessageBox.Show("Process Completed");
        }

       

        //Procedure ProcessVouchers
        private void ProcessVouchers()
        {
            long lLastVchID, lLastAlterID;

            //XQuery files
            string XQueryFileToPushMainVoucherTableData = strRTSXQueryPATH + "xquery-push-vouchers-main-table-into-database.xq";
            string XQueryFileToPushOtherVoucherTablesData = strRTSXQueryPATH + "xquery-push-vouchers-other-tables-into-database.xq";
            string XQueryFileToDeleteVouchersData = strRTSXQueryPATH + "xquery-delete-vouchers-from-database.xq"; ;

            //Connection string assigned to Class object
            oRTSXQuery.ConnectionString = strConnectionString;

            //Get the Last Voucher Id (VchID) from Table "vchmain". Returns -1 if table does not exist.
            lLastVchID = oRTSXQuery.GetFieldMaxValue("vchmain", "vchid");

            //Get the Last Alter Id (AlterID) from table "vchmain".  Returns -1 if table does not exist.
            lLastAlterID = oRTSXQuery.GetFieldMaxValue("vchmain", "alterid");
            if (lLastAlterID == -1)
            {
                lLastAlterID = 0;
            }

            //===================================================
            //STEP 1 - CreateVouchers 
            //===================================================
            //Step 1a - Tally to XML - Get the newly created vouchers from Tally which do not exist in Main-table "vchmain"
            lblstatus.Text = "Retrieve Voucher data from Tally...";
            lblstatus.Refresh();
            string strXMLResponse = TallyToXML(lLastVchID, -1);
            if ((strXMLResponse != null) && (strXMLResponse.Length == 0))
            {
                Application.Exit();
                return;
            }


            //Convert some tags to upper case
            strXMLResponse = ConvertSomeXMLTagsToUpperCase(strXMLResponse);

            lblstatus.Text = "Send data to main table...";
            lblstatus.Refresh();
            //Step 1b - XML to database - Transfer data to table "Vchmain"
            XMLToDatabase(strXMLResponse, XQueryFileToPushMainVoucherTableData);
            //You must Place two labels on the form viz a) lblCreated  b) lblCreated_Error
            lblCreated.Text = oRTSXQuery.RowsAffected.ToString();
            lblCreated_Error.Text = oRTSXQuery.ErrorCount.ToString();

            //If any error relating to "File Not found" occurs, then
            if ((oRTSXQuery.LastErrorNumber >0) && (oRTSXQuery.LastErrorNumber < 1000))
            {
                MessageBox.Show("Error: "+oRTSXQuery.LastErrorNumber.ToString()+"\n" + oRTSXQuery.LastErrorMessage);
                Application.Exit();
                return;
            }

            lblstatus.Text = "Send data to other tables database...";
            lblstatus.Refresh();
            
            //Step 1c - XML to database - Transfer data to Other tables
            XMLToDatabase(strXMLResponse, XQueryFileToPushOtherVoucherTablesData);

            //===================================================
            //STEP 2 - UpdateVouchers (Method: Delete & Insert)
            //===================================================
            //Steps 2a and 2b will delete vouchers from database which were altered in Tally
            //------------------------------------------------------------------------------
            //Step 2a - Get all vouchers-data into strXMLResponse which have been altered in Tally since last synchronize
            strXMLResponse = TallyToXML(lLastVchID, lLastAlterID);
            if ((strXMLResponse != null) && (strXMLResponse.Length == 0))
            {
                Application.Exit();
                return;
            }

            lblstatus.Text = "Update all such records in database which have been modified in Tally after last syn...";
            lblstatus.Refresh();
            //Step 2b - Delete voucher from database (only those vouchers which were altered in Tally)
            XMLToDatabase(strXMLResponse, XQueryFileToDeleteVouchersData);

            //Step 2c - Insert vouchers into Main table (only those vouchers which were altered in Tally)
            XMLToDatabase(strXMLResponse, XQueryFileToPushMainVoucherTableData);
            //You must Place two labels on the form viz a) lblAltered  b) lblAltered_Error
            lblAltered.Text = oRTSXQuery.RowsAffected.ToString();
            lblAltered_Error.Text = oRTSXQuery.ErrorCount.ToString();

            //Step 2d - XML to database - Other tables (only those vouchers which were altered in Tally)
            XMLToDatabase(strXMLResponse, XQueryFileToPushOtherVoucherTablesData);

        }


        private void ProcessMasters()
        {
            long lLastMasterID, lMastersCreated = 0, lMastersCreated_Error = 0;

            //XQuery files
            string XQueryFileToPushLedgerMasterTableData = strRTSXQueryPATH + "xquery-push-masters-ledgers-into-database.xq";
            string XQueryFileToPushGroupsMasterTableData = strRTSXQueryPATH + "xquery-push-masters-groups-into-database.xq";
            string XQueryFileToPushCostCentresMasterTableData = strRTSXQueryPATH + "xquery-push-masters-costcentres-into-database.xq";
            string XQueryFileToPushUnitMasterTableData = strRTSXQueryPATH + "xquery-push-masters-unit-into-database.xq";
            string XQueryFileToPushStockGroupMasterTableData = strRTSXQueryPATH + "xquery-push-masters-stockgroup-into-database.xq";
            string XQueryFileToPushGodownMasterTableData = strRTSXQueryPATH + "xquery-push-masters-godown-into-database.xq";
            string XQueryFileToPushStockItemMasterTableData = strRTSXQueryPATH + "xquery-push-masters-stockitem-into-database.xq";

            //Connection string assigned to Class object
            oRTSXQuery.ConnectionString = strConnectionString;

            //Ledger Master
            //===================================================================================
            //Get the Last MASTERID from Table "masterledger". Returns -1 if table does not exist.
            lblstatus.Text = "Retrieve Ledger Master data from Tally..";
            lblstatus.Refresh();
            lLastMasterID = oRTSXQuery.GetFieldMaxValue("masterledger", "masterid");
            //Step 1- Tally to XML
            string strSQL = "Select $masterid,$name,$parent,@@AcctGroupID,$openingbalance,$alteredon from Ledger where $masterid &gt; $$Number:\"" + lLastMasterID.ToString() + "\"";
            //MessageBox.Show(strSQL);
            oRTSlink.SQLRequest(strSQL, "");
            string strXMLResponse = oRTSlink.GetResponse();
            if ((strXMLResponse != null) && (strXMLResponse.Length == 0))
            {
                Application.Exit();
                return;
            }
            //Step 2 - XML to Database
            lblstatus.Text = "Insert Ledger Master data into database..";
            lblstatus.Refresh();
            XMLToDatabase(strXMLResponse, XQueryFileToPushLedgerMasterTableData);
            lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected;
            lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount;
            MastersCount(lMastersCreated, lMastersCreated_Error);

            //If any error relating to "File Not found" occurs, then
            if ((oRTSXQuery.LastErrorNumber > 0) && (oRTSXQuery.LastErrorNumber < 1000))
            {
                MessageBox.Show("Error: " + oRTSXQuery.LastErrorNumber.ToString() + "\n" + oRTSXQuery.LastErrorMessage);
                Application.Exit();
                return;
            }
            
            //===================================================================================
            //Group Master
            //===================================================================================
            //Get the Last MASTERID from Table "mastergroups". Returns -1 if table does not exist.
            lblstatus.Text = "Retrieve Group Master data from Tally..";
            lblstatus.Refresh();
            lLastMasterID = oRTSXQuery.GetFieldMaxValue("mastergroups", "masterid");
            //Step 1- Tally to XML
            strSQL = "Select $masterid,$name,$parent,$isrevenue,$isdeemedpositive,$alteredon from Groups where $masterid &gt; $$Number:\"" + lLastMasterID.ToString() + "\"";
            oRTSlink.SQLRequest(strSQL, "");
            strXMLResponse = oRTSlink.GetResponse();
            if ((strXMLResponse != null) && (strXMLResponse.Length == 0))
            {
                Application.Exit();
                return;
            }
            //Step 2 - XML to Database
            lblstatus.Text = "Insert Group Master data into database..";
            lblstatus.Refresh();
            XMLToDatabase(strXMLResponse, XQueryFileToPushGroupsMasterTableData);
            lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected;
            lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount;
            MastersCount(lMastersCreated, lMastersCreated_Error);
            //===================================================================================


            //===================================================================================
            //CostCentre Master
            //===================================================================================
            //Get the Last MASTERID from Table "mastercostcentres". Returns -1 if table does not exist.
            lblstatus.Text = "Retrieve CostCentre Master data from Tally..";
            lblstatus.Refresh();
            lLastMasterID = oRTSXQuery.GetFieldMaxValue("mastercostcentres", "masterid");
            //Step 1- Tally to XML
            strSQL = "Select $masterid,$name,$parent from CostCentres where $masterid &gt; $$Number:\"" + lLastMasterID.ToString() + "\"";
            oRTSlink.SQLRequest(strSQL, "");
            strXMLResponse = oRTSlink.GetResponse();
            if ((strXMLResponse != null) && (strXMLResponse.Length == 0))
            {
                Application.Exit();
                return;
            }
            //Step 2 - XML to Database
            lblstatus.Text = "Insert CostCentre Masters data into database..";
            lblstatus.Refresh();
            XMLToDatabase(strXMLResponse, XQueryFileToPushCostCentresMasterTableData);
            lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected;
            lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount;
            MastersCount(lMastersCreated, lMastersCreated_Error);


            //===================================================================================
            //UNIT Master
            //===================================================================================
            //Get the Last MASTERID from Table "masterunit". Returns -1 if table does not exist.
            lblstatus.Text = "Retrieve UNIT Master data from Tally..";
            lblstatus.Refresh();
            lLastMasterID = oRTSXQuery.GetFieldMaxValue("masterunit", "masterid");
            //Step 1- Tally to XML
            strSQL = "Select $masterid,$name,$formalname,$decimalplaces,$alteredon from UNIT where $masterid &gt; $$Number:\"" + lLastMasterID.ToString() + "\"";
            oRTSlink.SQLRequest(strSQL, "");
            strXMLResponse = oRTSlink.GetResponse();
            if ((strXMLResponse != null) && (strXMLResponse.Length == 0))
            {
                Application.Exit();
                return;
            }
            //Step 2 - XML to Database
            lblstatus.Text = "Insert UNIT Masters data into database..";
            lblstatus.Refresh();
            XMLToDatabase(strXMLResponse, XQueryFileToPushUnitMasterTableData);
            lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected;
            lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount;
            MastersCount(lMastersCreated, lMastersCreated_Error);

            //===================================================================================
            //StockGroup Master
            //===================================================================================
            //Get the Last MASTERID from Table "masterstockgroup". Returns -1 if table does not exist.
            lblstatus.Text = "Retrieve StockGroup Master data from Tally..";
            lblstatus.Refresh();
            lLastMasterID = oRTSXQuery.GetFieldMaxValue("MasterStockGroup", "masterid");
            //Step 1- Tally to XML
            strSQL = "Select $masterid,$name,$parent,$$alias,$alteredon from StockGroup where $masterid &gt; $$Number:\"" + lLastMasterID.ToString() + "\"";
            oRTSlink.SQLRequest(strSQL, "");
            strXMLResponse = oRTSlink.GetResponse();
            if ((strXMLResponse != null) && (strXMLResponse.Length == 0))
            {
                Application.Exit();
                return;
            }
            //Step 2 - XML to Database
            lblstatus.Text = "Insert StockGroup Masters data into database..";
            lblstatus.Refresh();
            XMLToDatabase(strXMLResponse, XQueryFileToPushStockGroupMasterTableData);
            lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected;
            lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount;
            MastersCount(lMastersCreated, lMastersCreated_Error);

            //===================================================================================
            //Godown Master
            //===================================================================================
            //Get the Last MASTERID from Table "masterGodown". Returns -1 if table does not exist.
            lblstatus.Text = "Retrieve Godown Master data from Tally..";
            lblstatus.Refresh();
            lLastMasterID = oRTSXQuery.GetFieldMaxValue("MasterGodown", "masterid");
            //Step 1- Tally to XML
            strSQL = "Select $masterid,$name,$parent,$$alias,$alteredon from Godown where $masterid &gt; $$Number:\"" + lLastMasterID.ToString() + "\"";
            oRTSlink.SQLRequest(strSQL, "");
            strXMLResponse = oRTSlink.GetResponse();
            if ((strXMLResponse != null) && (strXMLResponse.Length == 0))
            {
                Application.Exit();
                return;
            }
            //Step 2 - XML to Database
            lblstatus.Text = "Insert Godown Masters data into database..";
            lblstatus.Refresh();
            XMLToDatabase(strXMLResponse, XQueryFileToPushGodownMasterTableData);
            lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected;
            lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount;
            MastersCount(lMastersCreated, lMastersCreated_Error);

            //===================================================================================
            //StockItem Master
            //===================================================================================
            //Get the Last MASTERID from Table "masterStockItem". Returns -1 if table does not exist.
            lblstatus.Text = "Retrieve StockItem Master data from Tally..";
            lblstatus.Refresh();
            lLastMasterID = oRTSXQuery.GetFieldMaxValue("MasterStockItem", "masterid");
            //Step 1- Tally to XML
            strSQL = "Select $masterid,$name,$$alias,$parent,@@StockGroupId,$mailingname,$mailingname," +
                     "$category,$narration,$description,$baseunits,@@BaseUnitsId,$costingmethod,$valuationmethod," +
                     "$$Number:$openingbalance,$openingvalue,$$Number:$openingrate,$alteredon from StockItem where $masterid &gt; $$Number:\"" + lLastMasterID.ToString() + "\"";
            oRTSlink.SQLRequest(strSQL, "");
            strXMLResponse = oRTSlink.GetResponse();
            if ((strXMLResponse != null) && (strXMLResponse.Length == 0))
            {
                Application.Exit();
                return;
            }
            //Step 2 - XML to Database
            lblstatus.Text = "Insert StockItem Masters data into database..";
            lblstatus.Refresh();
            XMLToDatabase(strXMLResponse, XQueryFileToPushStockItemMasterTableData);
            lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected;
            lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount;
            MastersCount(lMastersCreated, lMastersCreated_Error);
        
        }

        private void MastersCount(long lMastersCreated,long lMastersCreated_Error)
        {
            //You must Place two labels on the form viz a) lblMastersCreated  b) lblMasters_Error
            lblMastersCreated.Text = lMastersCreated.ToString();
            lblMasters_Error.Text = lMastersCreated_Error.ToString();
            lblMastersCreated.Refresh();
            lblMasters_Error.Refresh();
        }


        //Tally to XML - Invoked from ProcessVouchers()
        private string TallyToXML(long lLastVchId, long lLastAlterId)
        {
            long lResult;
            string strXMLRequest, strXMLResponse;

            strXMLRequest = oRTSMisc.ReadTextFile(strRTSXQueryPATH + "XMLRequest-pull-vouchers-from-tally.xml");
            strXMLResponse = "";

            strXMLRequest = oRTSMisc.StrReplace(strXMLRequest, "##LASTVCHID##", lLastVchId.ToString());
            strXMLRequest = oRTSMisc.StrReplace(strXMLRequest, "##LASTALTERID##", lLastAlterId.ToString());

            //Send Request to Tally
            lResult = oRTSlink.Send(strXMLRequest);

            //Get Response
            if (lResult == 0)
            {
                strXMLResponse = oRTSlink.GetResponse();
                return strXMLResponse;
            }
            else
            {
                MessageBox.Show(oRTSlink.LastErrorMessage);
                return "";
            }

        }

        //XML to Database - Invoked from ProcessVouchers()
        private void XMLToDatabase(string strXMLResponse, string XQueryPushVouchersFileName)
        {
            string strXQueryResult, strLastErrorMessage;
            long lLastErrorNumber;

            oRTSXQuery.XML = strXMLResponse;
            oRTSXQuery.XQueryFromFile = XQueryPushVouchersFileName;

            //Execute query
            oRTSXQuery.SuppressCreateTableErrors = true;
            strXQueryResult = oRTSXQuery.Execute();

            strLastErrorMessage = oRTSXQuery.LastErrorMessage;
            lLastErrorNumber = oRTSXQuery.LastErrorNumber;

            if (strLastErrorMessage != null)
            {
                if (strLastErrorMessage.Length > 0)
                {
                    MessageBox.Show("Error No: " + lLastErrorNumber.ToString() + "\n" + strLastErrorMessage);
                }
            }
        
        }


        private string ConvertSomeXMLTagsToUpperCase(string strXMLdata)
        {
            strXMLdata = strXMLdata.Replace("Voucher ", "VOUCHER ");
            strXMLdata = strXMLdata.Replace("</Voucher>", "</VOUCHER>");
            strXMLdata = strXMLdata.Replace("Date", "DATE");
            strXMLdata = strXMLdata.Replace("VoucherTypeName", "VOUCHERTYPENAME");
            strXMLdata = strXMLdata.Replace("VoucherNumber", "VOUCHERNUMBER");
            strXMLdata = strXMLdata.Replace("PartyName", "PARTYNAME");
            strXMLdata = strXMLdata.Replace("PartyLedgerName", "PARTYLEDGERNAME");
            strXMLdata = strXMLdata.Replace("Reference", "REFERENCE");
            strXMLdata = strXMLdata.Replace("Narration", "NARRATION");
            strXMLdata = strXMLdata.Replace("LedgerName", "LEDGERNAME");
            strXMLdata = strXMLdata.Replace("Amount", "AMOUNT");
            strXMLdata = strXMLdata.Replace("ActualQty", "ACTUALQTY");
            strXMLdata = strXMLdata.Replace("CreatedBy", "CREATEDBY");
            strXMLdata = strXMLdata.Replace("AlteredBy", "ALTEREDBY");
            strXMLdata = strXMLdata.Replace("AlteredOn", "ALTEREDON");
            strXMLdata = strXMLdata.Replace("IsOptional", "ISOPTIONAL");
            strXMLdata = strXMLdata.Replace("IsCancelled", "ISCANCELLED");
            return strXMLdata;
        }

    }
}
